
;CodeVisionAVR C Compiler V2.05.0 Evaluation
;(C) Copyright 1998-2010 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type                : ATmega8535L
;Program type             : Application
;Clock frequency          : 16,000000 MHz
;Memory model             : Small
;Optimize for             : Size
;(s)printf features       : int, width
;(s)scanf features        : int, width
;External RAM size        : 0
;Data Stack size          : 128 byte(s)
;Heap size                : 0 byte(s)
;Promote 'char' to 'int'  : Yes
;'char' is unsigned       : Yes
;8 bit enums              : Yes
;global 'const' stored in FLASH: No
;Enhanced core instructions    : On
;Smart register allocation     : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATmega8535L
	#pragma AVRPART MEMORY PROG_FLASH 8192
	#pragma AVRPART MEMORY EEPROM 512
	#pragma AVRPART MEMORY INT_SRAM SIZE 607
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __SRAM_START=0x0060
	.EQU __SRAM_END=0x025F
	.EQU __DSTACK_SIZE=0x0080
	.EQU __HEAP_SIZE=0x0000
	.EQU __CLEAR_SRAM_SIZE=__SRAM_END-__SRAM_START+1

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ANDI R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ORI  R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __CLRD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+(@1))
	LDI  R31,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	LDI  R22,BYTE3(2*@0+(@1))
	LDI  R23,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+(@2))
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+(@3))
	LDI  R@1,HIGH(@2+(@3))
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+(@3))
	LDI  R@1,HIGH(@2*2+(@3))
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+(@1)
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+(@1)
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	LDS  R22,@0+(@1)+2
	LDS  R23,@0+(@1)+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+(@2)
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+(@3)
	LDS  R@1,@2+(@3)+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+(@1)
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	LDS  R24,@0+(@1)+2
	LDS  R25,@0+(@1)+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+(@1),R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	STS  @0+(@1)+2,R22
	STS  @0+(@1)+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+(@1),R0
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+(@1),R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+(@1),R@2
	STS  @0+(@1)+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTBSR
	STD  Y+@1,R@0
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	RCALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __GETD1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X+
	LD   R22,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	RCALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __GETBRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	LD   R@0,X
	.ENDM

	.MACRO __GETWRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	LD   R@0,X+
	LD   R@1,X
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __CLRD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R30
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	ST   Z,R@0
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

	.CSEG
	.ORG 0x00

;START OF CODE MARKER
__START_OF_CODE:

;INTERRUPT VECTORS
	RJMP __RESET
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP _timer2_ovf_isr
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP _timer0_ovf_isr
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00

_0x140003:
	.DB  0x0,0x0,0x0,0x81,0xF3,0x49,0x61,0x33
	.DB  0x25,0x5,0xF1,0x1,0x21,0xD,0x5F,0xFF
__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,(14-2)+1
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(__CLEAR_SRAM_SIZE)
	LDI  R25,HIGH(__CLEAR_SRAM_SIZE)
	LDI  R26,__SRAM_START
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;HARDWARE STACK POINTER INITIALIZATION
	LDI  R30,LOW(__SRAM_END-__HEAP_SIZE)
	OUT  SPL,R30
	LDI  R30,HIGH(__SRAM_END-__HEAP_SIZE)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(__SRAM_START+__DSTACK_SIZE)
	LDI  R29,HIGH(__SRAM_START+__DSTACK_SIZE)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0xE0

	.CSEG
;/*****************************************************
;This program was produced by the
;CodeWizardAVR V2.04.4a Advanced
;Automatic Program Generator
; Copyright 1998-2009 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com
;
;Project :
;Version :
;Date    : 03.10.2010
;Author  : NeVaDa
;Company : Microsoft
;Comments:
;
;
;Chip type               : ATmega8535L
;Program type            : Application
;AVR Core Clock frequency: 16,000000 MHz
;Memory model            : Small
;External RAM size       : 0
;Data Stack size         : 128
;*****************************************************/
;
;#include <mega8535.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x40
	.EQU __sm_mask=0xB0
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0xA0
	.EQU __sm_ext_standby=0xB0
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
;#include <delay.h>
;#include <peremenie_konst.h>
;#include <Initialization_CPU.h>
;#include <start_310.h>
;#include <timer2_ovf_isr.h>
;#include <ADC_I.h>
;#include <ADC_U.h>
;#include <PWM_control_I.h>
;//#include <PWM_control_U.h>
;#include <recoding.h>
;/*
;interrupt [TIM2_OVF] void timer2_ovf_isr(void){
; start1++;
;  if (start1==5){// start1  ==5
;  soft_start++;  //  soft_start  1
;  start1=0;      // start1
;  }
;  if (rejim==0 || rejim==1 && soft_start<zadanie_I){//         
;  OCR2=soft_start;                                  //  
;  }
;  if (rejim==2 || rejim==3 && soft_start<zadanie_U){//         
;  OCR2=soft_start;                                  //  
;  }
;  if (OCR2==zadanie_I || OCR2==zadanie_U){          //      
;  TIMSK=0x01; //      2      0 "00000001"
;  TCCR0=0x03; //   0         250 
;  start=1;    //   
;  }
; }
;*/
;
;
;void main(void)
; 0000 003A  {

	.CSEG
_main:
; 0000 003B   Initialization_CPU();
	RCALL _Initialization_CPU
; 0000 003C   start_310();
	RCALL _start_310
; 0000 003D   while (1){
_0x3:
; 0000 003E    /************************ *****************************************************************/
; 0000 003F    while (start==1 && rejim==0){//        
_0x6:
	LDS  R26,_start
	CPI  R26,LOW(0x1)
	BRNE _0x9
	LDS  R26,_rejim
	CPI  R26,LOW(0x0)
	BREQ _0xA
_0x9:
	RJMP _0x8
_0xA:
; 0000 0040    ADC_I();                     //  
	RCALL _ADC_I
; 0000 0041    PWM_control_I();             //    
	RCALL _PWM_control_I
; 0000 0042    ADC_U();                     // 
	RCALL _ADC_U
; 0000 0043    recoding ();                 //     
	RCALL _recoding
; 0000 0044     //if (b_bolshe==0 || b_menshe==0 || b_rejim==0 || b_parametr==0){//    
; 0000 0045     //TCCR2=0x00;                   //           
; 0000 0046    // button_work=0;                //       
; 0000 0047      //while (button_work<10){      //       2 
; 0000 0048     // button();                     // 
; 0000 0049      //recoding ();                  //     
; 0000 004A     // led_rejim();                 //     
; 0000 004B     // }
; 0000 004C    // TCCR2=0x6E;                  // 
; 0000 004D     //}
; 0000 004E    //led_rejim();                 //     
; 0000 004F    }
	RJMP _0x6
_0x8:
; 0000 0050 
; 0000 0051 
; 0000 0052 
; 0000 0053 
; 0000 0054 
; 0000 0055 
; 0000 0056 
; 0000 0057 
; 0000 0058 
; 0000 0059 
; 0000 005A 
; 0000 005B     }//  while (1)
	RJMP _0x3
; 0000 005C  }// main
_0xB:
	RJMP _0xB
;
;
;#include <mega8535.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x40
	.EQU __sm_mask=0xB0
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0xA0
	.EQU __sm_ext_standby=0xB0
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
;#include <delay.h>
;#include <Initialization_CPU.h>
;#include <peremenie_konst.h>
;
; void start_310 (void){ //       
; 0001 0006 void start_310 (void){

	.CSEG
_start_310:
; 0001 0007  delay_ms (40);       // 4       
	LDI  R30,LOW(40)
	LDI  R31,HIGH(40)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
; 0001 0008  PORTB.0=1;             //   
	SBI  0x18,0
; 0001 0009   if (zadanie_I==0){    //    0
	RCALL SUBOPT_0x0
	CPI  R30,0
	BRNE _0x20005
; 0001 000A   zadanie_I=1;          //    
	LDI  R30,LOW(1)
	STS  _zadanie_I,R30
; 0001 000B   //zadanie_I_eep=zadanie_I;
; 0001 000C   }
; 0001 000D   if (zadanie_U==0){    //    0
_0x20005:
	LDS  R30,_zadanie_U
	CPI  R30,0
	BRNE _0x20006
; 0001 000E   zadanie_U=1;          //    
	LDI  R30,LOW(1)
	STS  _zadanie_U,R30
; 0001 000F   //zadanie_U_eep=zadanie_U;
; 0001 0010   }
; 0001 0011  delay_ms (20);       // 2 
_0x20006:
	LDI  R30,LOW(20)
	LDI  R31,HIGH(20)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
; 0001 0012  TCCR2=0x7A;            //  2    
	LDI  R30,LOW(122)
	OUT  0x25,R30
; 0001 0013  TIMSK=0x40;           //    2  
	LDI  R30,LOW(64)
	OUT  0x39,R30
; 0001 0014  }
	RET
;#include <mega8535.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x40
	.EQU __sm_mask=0xB0
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0xA0
	.EQU __sm_ext_standby=0xB0
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
;
;void Initialization_CPU (void){
; 0002 0003 void Initialization_CPU (void){

	.CSEG
_Initialization_CPU:
; 0002 0004 // Declare your local variables here
; 0002 0005 
; 0002 0006 // Input/Output Ports initialization
; 0002 0007 // Port A initialization
; 0002 0008 // Func7=Out Func6=Out Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out
; 0002 0009 // State7=0 State6=0 State5=0 State4=0 State3=0 State2=0 State1=0 State0=0
; 0002 000A PORTA=0x00;
	LDI  R30,LOW(0)
	OUT  0x1B,R30
; 0002 000B DDRA=0xFF;
	LDI  R30,LOW(255)
	OUT  0x1A,R30
; 0002 000C 
; 0002 000D // Port B initialization
; 0002 000E // Func7=Out Func6=Out Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out
; 0002 000F // State7=0 State6=0 State5=0 State4=0 State3=0 State2=0 State1=0 State0=0
; 0002 0010 PORTB=0x00;
	LDI  R30,LOW(0)
	OUT  0x18,R30
; 0002 0011 DDRB=0xFF;
	LDI  R30,LOW(255)
	OUT  0x17,R30
; 0002 0012 
; 0002 0013 // Port C initialization
; 0002 0014 // Func7=Out Func6=Out Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out
; 0002 0015 // State7=0 State6=0 State5=0 State4=0 State3=0 State2=0 State1=0 State0=0
; 0002 0016 PORTC=0x00;
	LDI  R30,LOW(0)
	OUT  0x15,R30
; 0002 0017 DDRC=0xFF;
	LDI  R30,LOW(255)
	OUT  0x14,R30
; 0002 0018 
; 0002 0019 // Port D initialization
; 0002 001A // Func7=Out Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
; 0002 001B // State7=0 State6=T State5=T State4=T State3=T State2=T State1=T State0=T
; 0002 001C PORTD=0x00;
	LDI  R30,LOW(0)
	OUT  0x12,R30
; 0002 001D DDRD=0x80;
	LDI  R30,LOW(128)
	OUT  0x11,R30
; 0002 001E 
; 0002 001F // Timer/Counter 0 initialization
; 0002 0020 // Clock source: System Clock
; 0002 0021 // Clock value: Timer 0 Stopped
; 0002 0022 // Mode: Normal top=0xFF
; 0002 0023 // OC0 output: Disconnected
; 0002 0024 TCCR0=0x00;
	LDI  R30,LOW(0)
	OUT  0x33,R30
; 0002 0025 TCNT0=0x00;
	OUT  0x32,R30
; 0002 0026 OCR0=0x00;
	OUT  0x3C,R30
; 0002 0027 
; 0002 0028 // Timer/Counter 1 initialization
; 0002 0029 // Clock source: System Clock
; 0002 002A // Clock value: Timer1 Stopped
; 0002 002B // Mode: Normal top=0xFFFF
; 0002 002C // OC1A output: Discon.
; 0002 002D // OC1B output: Discon.
; 0002 002E // Noise Canceler: Off
; 0002 002F // Input Capture on Falling Edge
; 0002 0030 // Timer1 Overflow Interrupt: Off
; 0002 0031 // Input Capture Interrupt: Off
; 0002 0032 // Compare A Match Interrupt: Off
; 0002 0033 // Compare B Match Interrupt: Off
; 0002 0034 TCCR1A=0x00;
	OUT  0x2F,R30
; 0002 0035 TCCR1B=0x00;
	OUT  0x2E,R30
; 0002 0036 TCNT1H=0x00;
	OUT  0x2D,R30
; 0002 0037 TCNT1L=0x00;
	OUT  0x2C,R30
; 0002 0038 ICR1H=0x00;
	OUT  0x27,R30
; 0002 0039 ICR1L=0x00;
	OUT  0x26,R30
; 0002 003A OCR1AH=0x00;
	OUT  0x2B,R30
; 0002 003B OCR1AL=0x00;
	OUT  0x2A,R30
; 0002 003C OCR1BH=0x00;
	OUT  0x29,R30
; 0002 003D OCR1BL=0x00;
	OUT  0x28,R30
; 0002 003E 
; 0002 003F 
; 0002 0040 // Timer/Counter 2 initialization
; 0002 0041 // Clock source: System Clock
; 0002 0042 // Clock value: Timer2 Stopped
; 0002 0043 // Mode: Normal top=0xFF
; 0002 0044 // OC2 output: Disconnected
; 0002 0045 ASSR=0x00;
	OUT  0x22,R30
; 0002 0046 TCCR2=0x00;
	OUT  0x25,R30
; 0002 0047 TCNT2=0x00;
	OUT  0x24,R30
; 0002 0048 OCR2=0x00;
	OUT  0x23,R30
; 0002 0049 
; 0002 004A // External Interrupt(s) initialization
; 0002 004B // INT0: Off
; 0002 004C // INT1: Off
; 0002 004D // INT2: Off
; 0002 004E MCUCR=0x00;
	OUT  0x35,R30
; 0002 004F MCUCSR=0x00;
	OUT  0x34,R30
; 0002 0050 
; 0002 0051 // Timer(s)/Counter(s) Interrupt(s) initialization
; 0002 0052 TIMSK=0x00;
	OUT  0x39,R30
; 0002 0053 
; 0002 0054 // USART initialization
; 0002 0055 // USART disabled
; 0002 0056 UCSRB=0x00;
	OUT  0xA,R30
; 0002 0057 
; 0002 0058 // Analog Comparator initialization
; 0002 0059 // Analog Comparator: Off
; 0002 005A // Analog Comparator Input Capture by Timer/Counter 1: Off
; 0002 005B ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x8,R30
; 0002 005C SFIOR=0x00;
	LDI  R30,LOW(0)
	OUT  0x30,R30
; 0002 005D 
; 0002 005E // ADC initialization
; 0002 005F // ADC disabled
; 0002 0060 ADCSRA=0x00;
	OUT  0x6,R30
; 0002 0061 
; 0002 0062 // SPI initialization
; 0002 0063 // SPI disabled
; 0002 0064 SPCR=0x00;
	OUT  0xD,R30
; 0002 0065 
; 0002 0066 // TWI initialization
; 0002 0067 // TWI disabled
; 0002 0068 TWCR=0x00;
	OUT  0x36,R30
; 0002 0069 // Global enable interrupts
; 0002 006A #asm("sei")
	sei
; 0002 006B }
	RET
;#define l_pad PORTD.4
;#define l_pad_pulse PORTD.5
;#define l_jest PORTD.6
;#define l_jest_pulse PORTB.5
;#define l_alarm PORTB.7
;#define b_bolshe PIND.0                                        // 
;#define b_menshe PIND.1                                        // 
;#define b_rejim PIND.2                                         //  
;#define b_parametr PIND.3                                      //  
;
;volatile unsigned char zadanie_I; //    
;volatile unsigned char zadanie_U; //    
;volatile unsigned char soft_start;//  
;volatile unsigned char start1;    //   5   
;volatile unsigned char start;     //    0   , 1  
;volatile unsigned char rejim;     //      
;/* rejim
;0  
;1   
;2  
;3   
;*/
;volatile unsigned char I_ADC;      //   I
;volatile unsigned char izmerenoe_I;//        
;volatile unsigned char U_ADC;      //   U
;volatile unsigned char izmerenoe_U;//        
;volatile unsigned int divider_500;//  500 500   
;volatile unsigned char divider_indy;//    
;volatile long int divider_125000;//  125000 0,5
;volatile unsigned int divider_2500;//  2500 100   
;volatile unsigned char button_work;   //     1 
;volatile unsigned char divider_button;//  
;volatile unsigned int divider_250;//  250 1000   
;volatile unsigned char divider_pulse;//   500
;volatile unsigned char calculator_bufer_I[4];//    
;volatile unsigned char calculator_bufer_U[4];//    
;
;
;#include <mega8535.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x40
	.EQU __sm_mask=0xB0
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0xA0
	.EQU __sm_ext_standby=0xB0
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
;#include <delay.h>
;#include <Initialization_CPU.h>
;#include <peremenie_konst.h>
;
; interrupt [TIM2_OVF] void timer2_ovf_isr(void){
; 0004 0006 interrupt [5] void timer2_ovf_isr(void){

	.CSEG
_timer2_ovf_isr:
	ST   -Y,R26
	ST   -Y,R30
	IN   R30,SREG
	ST   -Y,R30
; 0004 0007  start1++;
	LDS  R30,_start1
	SUBI R30,-LOW(1)
	STS  _start1,R30
; 0004 0008   if (start1==5){// start1  ==5
	LDS  R26,_start1
	CPI  R26,LOW(0x5)
	BRNE _0x80003
; 0004 0009   soft_start++;  //  soft_start  1
	RCALL SUBOPT_0x1
	SUBI R30,-LOW(1)
	STS  _soft_start,R30
; 0004 000A   start1=0;      // start1
	LDI  R30,LOW(0)
	STS  _start1,R30
; 0004 000B   }
; 0004 000C   if (rejim==0 || rejim==1 && soft_start<=zadanie_I){//         
_0x80003:
	RCALL SUBOPT_0x2
	CPI  R26,LOW(0x0)
	BREQ _0x80005
	RCALL SUBOPT_0x2
	CPI  R26,LOW(0x1)
	BRNE _0x80006
	RCALL SUBOPT_0x0
	LDS  R26,_soft_start
	CP   R30,R26
	BRSH _0x80005
_0x80006:
	RJMP _0x80004
_0x80005:
; 0004 000D   OCR2=soft_start;                                  //  
	RCALL SUBOPT_0x1
	OUT  0x23,R30
; 0004 000E   }
; 0004 000F   if (rejim==2 || rejim==3 && soft_start<=zadanie_U){//         
_0x80004:
	RCALL SUBOPT_0x2
	CPI  R26,LOW(0x2)
	BREQ _0x8000A
	RCALL SUBOPT_0x2
	CPI  R26,LOW(0x3)
	BRNE _0x8000B
	LDS  R30,_zadanie_U
	LDS  R26,_soft_start
	CP   R30,R26
	BRSH _0x8000A
_0x8000B:
	RJMP _0x80009
_0x8000A:
; 0004 0010   OCR2=soft_start;                                  //  
	RCALL SUBOPT_0x1
	OUT  0x23,R30
; 0004 0011   }
; 0004 0012   if (OCR2==zadanie_I || OCR2==zadanie_U){          //      
_0x80009:
	IN   R30,0x23
	MOV  R26,R30
	RCALL SUBOPT_0x0
	CP   R30,R26
	BREQ _0x8000F
	IN   R30,0x23
	MOV  R26,R30
	LDS  R30,_zadanie_U
	CP   R30,R26
	BRNE _0x8000E
_0x8000F:
; 0004 0013   TIMSK=0x01; //      2      0 "00000001"
	LDI  R30,LOW(1)
	OUT  0x39,R30
; 0004 0014   TCCR0=0x03; //   0         250 
	LDI  R30,LOW(3)
	OUT  0x33,R30
; 0004 0015   start=1;    //   
	LDI  R30,LOW(1)
	STS  _start,R30
; 0004 0016   }
; 0004 0017  }
_0x8000E:
	LD   R30,Y+
	OUT  SREG,R30
	LD   R30,Y+
	LD   R26,Y+
	RETI
;#include <mega8535.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x40
	.EQU __sm_mask=0xB0
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0xA0
	.EQU __sm_ext_standby=0xB0
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
;#include <delay.h>
;#include <Initialization_CPU.h>
;#include <peremenie_konst.h>
;// 0    250 .     .
; interrupt [TIM0_OVF] void timer0_ovf_isr(void){
; 0005 0006 interrupt [10] void timer0_ovf_isr(void){

	.CSEG
_timer0_ovf_isr:
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R24
	ST   -Y,R25
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
; 0005 0007  divider_500++;               // 500   
	LDI  R26,LOW(_divider_500)
	LDI  R27,HIGH(_divider_500)
	RCALL SUBOPT_0x3
; 0005 0008   if (divider_500==500){
	LDS  R26,_divider_500
	LDS  R27,_divider_500+1
	CPI  R26,LOW(0x1F4)
	LDI  R30,HIGH(0x1F4)
	CPC  R27,R30
	BRNE _0xA0003
; 0005 0009   divider_500=0;
	LDI  R30,LOW(0)
	STS  _divider_500,R30
	STS  _divider_500+1,R30
; 0005 000A   divider_indy=1;
	LDI  R30,LOW(1)
	STS  _divider_indy,R30
; 0005 000B   }
; 0005 000C  divider_125000++;            // 0,5
_0xA0003:
	LDI  R26,LOW(_divider_125000)
	LDI  R27,HIGH(_divider_125000)
	RCALL __GETD1P_INC
	__SUBD1N -1
	RCALL __PUTDP1_DEC
; 0005 000D   if (divider_125000==125000){
	LDS  R26,_divider_125000
	LDS  R27,_divider_125000+1
	LDS  R24,_divider_125000+2
	LDS  R25,_divider_125000+3
	__CPD2N 0x1E848
	BRNE _0xA0004
; 0005 000E   divider_125000=0;
	LDI  R30,LOW(0)
	STS  _divider_125000,R30
	STS  _divider_125000+1,R30
	STS  _divider_125000+2,R30
	STS  _divider_125000+3,R30
; 0005 000F   }
; 0005 0010  divider_2500++;              // 100   
_0xA0004:
	LDI  R26,LOW(_divider_2500)
	LDI  R27,HIGH(_divider_2500)
	RCALL SUBOPT_0x3
; 0005 0011   if (divider_2500==2500){
	LDS  R26,_divider_2500
	LDS  R27,_divider_2500+1
	CPI  R26,LOW(0x9C4)
	LDI  R30,HIGH(0x9C4)
	CPC  R27,R30
	BRNE _0xA0005
; 0005 0012   divider_2500=0;
	LDI  R30,LOW(0)
	STS  _divider_2500,R30
	STS  _divider_2500+1,R30
; 0005 0013   divider_button=1;
	LDI  R30,LOW(1)
	STS  _divider_button,R30
; 0005 0014    if (divider_button==1){
	LDS  R26,_divider_button
	CPI  R26,LOW(0x1)
	BRNE _0xA0006
; 0005 0015    button_work++;
	LDS  R30,_button_work
	SUBI R30,-LOW(1)
	STS  _button_work,R30
; 0005 0016     if (button_work==201){
	LDS  R26,_button_work
	CPI  R26,LOW(0xC9)
	BRNE _0xA0007
; 0005 0017     button_work=0;
	LDI  R30,LOW(0)
	STS  _button_work,R30
; 0005 0018     }
; 0005 0019    }
_0xA0007:
; 0005 001A   }
_0xA0006:
; 0005 001B  divider_250++;              // 1000   
_0xA0005:
	LDI  R26,LOW(_divider_250)
	LDI  R27,HIGH(_divider_250)
	RCALL SUBOPT_0x3
; 0005 001C   if (divider_250==125){
	RCALL SUBOPT_0x4
	CPI  R26,LOW(0x7D)
	LDI  R30,HIGH(0x7D)
	CPC  R27,R30
	BRNE _0xA0008
; 0005 001D   divider_pulse=1;
	LDI  R30,LOW(1)
	STS  _divider_pulse,R30
; 0005 001E   }
; 0005 001F   if (divider_250==250){
_0xA0008:
	RCALL SUBOPT_0x4
	CPI  R26,LOW(0xFA)
	LDI  R30,HIGH(0xFA)
	CPC  R27,R30
	BRNE _0xA0009
; 0005 0020   divider_pulse=0;
	LDI  R30,LOW(0)
	STS  _divider_pulse,R30
; 0005 0021   }
; 0005 0022  }
_0xA0009:
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R24,Y+
	LD   R23,Y+
	LD   R22,Y+
	RETI
;#include <mega8535.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x40
	.EQU __sm_mask=0xB0
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0xA0
	.EQU __sm_ext_standby=0xB0
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
;#include <delay.h>
;#include <Initialization_CPU.h>
;#include <peremenie_konst.h>
;//  ADC6  
; void ADC_I (void){ //  ADC6
; 0006 0006 void ADC_I (void){

	.CSEG
_ADC_I:
; 0006 0007  ADMUX=0b00100110;
	LDI  R30,LOW(38)
	RCALL SUBOPT_0x5
; 0006 0008  ADCSRA=0b11000001;// 2
; 0006 0009  delay_us(8);
; 0006 000A  I_ADC=ADCH;
	STS  _I_ADC,R30
; 0006 000B  calculator_bufer_I[3]=calculator_bufer_I[2];
	__GETB1MN _calculator_bufer_I,2
	__PUTB1MN _calculator_bufer_I,3
; 0006 000C  calculator_bufer_I[2]=calculator_bufer_I[1];
	__GETB1MN _calculator_bufer_I,1
	__PUTB1MN _calculator_bufer_I,2
; 0006 000D  calculator_bufer_I[1]=calculator_bufer_I[0];
	LDS  R30,_calculator_bufer_I
	__PUTB1MN _calculator_bufer_I,1
; 0006 000E  calculator_bufer_I[0]=I_ADC;
	LDS  R30,_I_ADC
	STS  _calculator_bufer_I,R30
; 0006 000F  izmerenoe_I=(calculator_bufer_I[3]+calculator_bufer_I[2]+calculator_bufer_I[1]+calculator_bufer_I[0])/4;
	__GETB2MN _calculator_bufer_I,3
	CLR  R27
	__GETB1MN _calculator_bufer_I,2
	RCALL SUBOPT_0x6
	__GETB1MN _calculator_bufer_I,1
	RCALL SUBOPT_0x6
	LDS  R30,_calculator_bufer_I
	RCALL SUBOPT_0x6
	LDI  R30,LOW(4)
	LDI  R31,HIGH(4)
	RCALL __DIVW21
	STS  _izmerenoe_I,R30
; 0006 0010  }
	RET
;#include <mega8535.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x40
	.EQU __sm_mask=0xB0
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0xA0
	.EQU __sm_ext_standby=0xB0
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
;#include <delay.h>
;#include <Initialization_CPU.h>
;#include <peremenie_konst.h>
;
;//  ADC7  
; void ADC_U (void){ //  ADC7
; 0007 0007 void ADC_U (void){

	.CSEG
_ADC_U:
; 0007 0008  ADMUX=0b00100111;
	LDI  R30,LOW(39)
	RCALL SUBOPT_0x5
; 0007 0009  ADCSRA=0b11000001;// 2
; 0007 000A  delay_us(8);
; 0007 000B  U_ADC=ADCH;
	STS  _U_ADC,R30
; 0007 000C  calculator_bufer_U[3]=calculator_bufer_U[2];
	__GETB1MN _calculator_bufer_U,2
	__PUTB1MN _calculator_bufer_U,3
; 0007 000D  calculator_bufer_U[2]=calculator_bufer_U[1];
	__GETB1MN _calculator_bufer_U,1
	__PUTB1MN _calculator_bufer_U,2
; 0007 000E  calculator_bufer_U[1]=calculator_bufer_U[0];
	LDS  R30,_calculator_bufer_U
	__PUTB1MN _calculator_bufer_U,1
; 0007 000F  calculator_bufer_U[0]=U_ADC;
	LDS  R30,_U_ADC
	STS  _calculator_bufer_U,R30
; 0007 0010  izmerenoe_U=(calculator_bufer_U[3]+calculator_bufer_U[2]+calculator_bufer_U[1]+calculator_bufer_U[0])/4;
	__GETB2MN _calculator_bufer_U,3
	CLR  R27
	__GETB1MN _calculator_bufer_U,2
	RCALL SUBOPT_0x6
	__GETB1MN _calculator_bufer_U,1
	RCALL SUBOPT_0x6
	LDS  R30,_calculator_bufer_U
	RCALL SUBOPT_0x6
	LDI  R30,LOW(4)
	LDI  R31,HIGH(4)
	RCALL __DIVW21
	STS  _izmerenoe_U,R30
; 0007 0011  }
	RET
;#include <mega8535.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x40
	.EQU __sm_mask=0xB0
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0xA0
	.EQU __sm_ext_standby=0xB0
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
;#include <delay.h>
;#include <Initialization_CPU.h>
;#include <peremenie_konst.h>
;
;// 
; void PWM_control_I(void){
; 0008 0007 void PWM_control_I(void){

	.CSEG
_PWM_control_I:
; 0008 0008  volatile unsigned char control_I;//      
; 0008 0009  control_I=izmerenoe_I;
	SBIW R28,1
;	control_I -> Y+0
	LDS  R30,_izmerenoe_I
	ST   Y,R30
; 0008 000A   if ((izmerenoe_I < zadanie_I)){ //     
	RCALL SUBOPT_0x0
	LDS  R26,_izmerenoe_I
	CP   R26,R30
	BRSH _0x100003
; 0008 000B   control_I++;                    //      1 
	LD   R30,Y
	SUBI R30,-LOW(1)
	ST   Y,R30
; 0008 000C   OCR2=control_I;                 //          
	OUT  0x23,R30
; 0008 000D   }
; 0008 000E   if ((izmerenoe_I > zadanie_I)){ //     
_0x100003:
	RCALL SUBOPT_0x0
	LDS  R26,_izmerenoe_I
	CP   R30,R26
	BRSH _0x100004
; 0008 000F   soft_start--;                   //      1 
	RCALL SUBOPT_0x1
	SUBI R30,LOW(1)
	STS  _soft_start,R30
; 0008 0010   OCR2=soft_start;                //          
	RCALL SUBOPT_0x1
	OUT  0x23,R30
; 0008 0011   }
; 0008 0012  }
_0x100004:
	ADIW R28,1
	RET
;#include <mega8535.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x40
	.EQU __sm_mask=0xB0
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0xA0
	.EQU __sm_ext_standby=0xB0
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
;#include <delay.h>
;#include <Initialization_CPU.h>
;#include <peremenie_konst.h>
;
;// 
; void PWM_control_U(void){
; 0009 0007 void PWM_control_U(void){

	.CSEG
; 0009 0008  volatile unsigned char control_U;//      
; 0009 0009  control_U=izmerenoe_U;
;	control_U -> Y+0
; 0009 000A   if (izmerenoe_U < zadanie_U){   //     
; 0009 000B   control_U++;                    //      1 
; 0009 000C   OCR2=control_U;                 //          
; 0009 000D   }
; 0009 000E   if (izmerenoe_U > zadanie_U){   //     
; 0009 000F   control_U--;                    //      1 
; 0009 0010   OCR2=control_U;                 //          
; 0009 0011   }
; 0009 0012  }
;#include <mega8535.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x40
	.EQU __sm_mask=0xB0
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0xA0
	.EQU __sm_ext_standby=0xB0
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
;#include <delay.h>
;#include <Initialization_CPU.h>
;#include <peremenie_konst.h>
;
;/******************************************* ************************************************/
;#define dig1I PORTA.2//PORTD.5         dig1I
;#define dig2I PORTA.1//PORTD.6         dig2I
;#define dig3I PORTA.0//PORTD.7        dig3I
;#define dig1U PORTA.5//PORTD.5         dig1U
;#define dig2U PORTA.4//PORTD.6         dig2U
;#define dig3U PORTA.3//PORTD.7        dig3U
;
; void recoding (void){
; 000A 000E void recoding (void){

	.CSEG
_recoding:
; 000A 000F   unsigned char sym[]={
; 000A 0010   0b10000001, //(0)0
; 000A 0011   0b11110011, //(1)1
; 000A 0012   0b01001001, //(2)2
; 000A 0013   0b01100001, //(3)3
; 000A 0014   0b00110011, //(4)4
; 000A 0015   0b00100101, //(5)5
; 000A 0016   0b00000101, //(6)6
; 000A 0017   0b11110001, //(7)7
; 000A 0018   0b00000001, //(8)8
; 000A 0019   0b00100001, //(9)9
; 000A 001A   0b00001101, //(10)E
; 000A 001B   0b01011111, //(11)r
; 000A 001C   0b11111111  //(12)  
; 000A 001D   };
; 000A 001E  volatile unsigned char indy_static_I;//         
; 000A 001F  volatile unsigned char indy_static_U;//         
; 000A 0020  volatile unsigned char cur_dig=0;      //  
; 000A 0021  volatile unsigned char sym_out[6];   // sym_out   ( 6)        
; 000A 0022  volatile unsigned char indy_I;       //         
; 000A 0023  volatile unsigned char indy_U;       //         
; 000A 0024  /******************************************** *************************************************/
; 000A 0025    if (divider_indy==1){   //    (divider_indy   ,    )
	SBIW R28,24
	LDI  R24,16
	LDI  R26,LOW(8)
	LDI  R27,HIGH(8)
	LDI  R30,LOW(_0x140003*2)
	LDI  R31,HIGH(_0x140003*2)
	RCALL __INITLOCB
;	sym -> Y+11
;	indy_static_I -> Y+10
;	indy_static_U -> Y+9
;	cur_dig -> Y+8
;	sym_out -> Y+2
;	indy_I -> Y+1
;	indy_U -> Y+0
	LDS  R26,_divider_indy
	CPI  R26,LOW(0x1)
	BREQ PC+2
	RJMP _0x140004
; 000A 0026    indy_I=izmerenoe_I;     //          ()
	LDS  R30,_izmerenoe_I
	STD  Y+1,R30
; 000A 0027    indy_static_I=indy_I;   // indy_static_I        
	STD  Y+10,R30
; 000A 0028    indy_U=izmerenoe_U;     //          ()
	LDS  R30,_izmerenoe_U
	ST   Y,R30
; 000A 0029    indy_static_U=indy_U;   // indy_static_U        
	STD  Y+9,R30
; 000A 002A    if (indy_static_I<255){ //  indy_static_I  255
	LDD  R26,Y+10
	CPI  R26,LOW(0xFF)
	BRSH _0x140005
; 000A 002B    sym_out[0]=indy_I%10;   //  sym_out 0    
	RCALL SUBOPT_0x7
	STD  Y+2,R30
; 000A 002C    indy_I=indy_I/10;       //  indy_I         
	RCALL SUBOPT_0x8
; 000A 002D    sym_out[1]=indy_I%10;   //    
	RCALL SUBOPT_0x7
	STD  Y+3,R30
; 000A 002E    indy_I=indy_I/10;       //    
	RCALL SUBOPT_0x8
; 000A 002F    sym_out[2]=indy_I;      //      
	LDD  R30,Y+1
	RJMP _0x14006C
; 000A 0030    }
; 000A 0031    else                    // 
_0x140005:
; 000A 0032    {
; 000A 0033    sym_out[0]=11;          //
	LDI  R30,LOW(11)
	STD  Y+2,R30
; 000A 0034    sym_out[1]=10;          //Er
	LDI  R30,LOW(10)
	STD  Y+3,R30
; 000A 0035    sym_out[2]=12;          // 0   
	LDI  R30,LOW(12)
_0x14006C:
	STD  Y+4,R30
; 000A 0036    }
; 000A 0037    /*************************************** *********************************************/
; 000A 0038    if (indy_static_U<255){  //  indy_static_U  255
	LDD  R26,Y+9
	CPI  R26,LOW(0xFF)
	BRSH _0x140007
; 000A 0039    sym_out[3]=indy_U%10;    //  sym_out 0    
	RCALL SUBOPT_0x9
	STD  Y+5,R30
; 000A 003A    indy_U=indy_U/10;        //  indy_I         
	RCALL SUBOPT_0xA
; 000A 003B    sym_out[4]=indy_U%10;    //    
	RCALL SUBOPT_0x9
	STD  Y+6,R30
; 000A 003C    indy_U=indy_U/10;        //    
	RCALL SUBOPT_0xA
; 000A 003D    sym_out[5]=indy_U;       //      
	LD   R30,Y
	RJMP _0x14006D
; 000A 003E    }
; 000A 003F    else                     // 
_0x140007:
; 000A 0040    {
; 000A 0041    sym_out[3]=11;           //
	LDI  R30,LOW(11)
	STD  Y+5,R30
; 000A 0042    sym_out[4]=10;           //Er
	LDI  R30,LOW(10)
	STD  Y+6,R30
; 000A 0043    sym_out[5]=12;           // 0   
	LDI  R30,LOW(12)
_0x14006D:
	STD  Y+7,R30
; 000A 0044    }
; 000A 0045 
; 000A 0046     /***********************************     **************************************/
; 000A 0047    PORTC=sym[12];                                                         //  C
	LDD  R30,Y+23
	OUT  0x15,R30
; 000A 0048    switch (cur_dig){                                                      //   
	RCALL SUBOPT_0xB
; 000A 0049    case 0:{dig1I=1; dig2I=0; dig3I=0; dig1U=0; dig2U=0; dig3U=0; break;}; //    1 
	SBIW R30,0
	BRNE _0x14000C
	SBI  0x1B,2
	CBI  0x1B,1
	CBI  0x1B,0
	RCALL SUBOPT_0xC
	RJMP _0x14000B
; 000A 004A    case 1:{dig2I=1; dig3I=0; dig1I=0; dig1U=0; dig2U=0; dig3U=0; break;}; //    2 
_0x14000C:
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	BRNE _0x140019
	SBI  0x1B,1
	RCALL SUBOPT_0xD
	RCALL SUBOPT_0xC
	RJMP _0x14000B
; 000A 004B    case 2:{dig3I=1; dig1I=0; dig2I=0; dig1U=0; dig2U=0; dig3U=0; break;}; //    3 
_0x140019:
	CPI  R30,LOW(0x2)
	LDI  R26,HIGH(0x2)
	CPC  R31,R26
	BRNE _0x140026
	SBI  0x1B,0
	CBI  0x1B,2
	CBI  0x1B,1
	RCALL SUBOPT_0xC
	RJMP _0x14000B
; 000A 004C    case 3:{dig1U=1; dig3I=0; dig1I=0; dig2I=0; dig2U=0; dig3U=0; break;}; //    1 
_0x140026:
	CPI  R30,LOW(0x3)
	LDI  R26,HIGH(0x3)
	CPC  R31,R26
	BRNE _0x140033
	SBI  0x1B,5
	RCALL SUBOPT_0xD
	CBI  0x1B,1
	CBI  0x1B,4
	CBI  0x1B,3
	RJMP _0x14000B
; 000A 004D    case 4:{dig2U=1; dig1U=0; dig3I=0; dig1I=0; dig2I=0; dig3U=0; break;}; //    2 
_0x140033:
	CPI  R30,LOW(0x4)
	LDI  R26,HIGH(0x4)
	CPC  R31,R26
	BRNE _0x140040
	SBI  0x1B,4
	CBI  0x1B,5
	RCALL SUBOPT_0xD
	CBI  0x1B,1
	CBI  0x1B,3
	RJMP _0x14000B
; 000A 004E    case 5:{dig3U=1; dig2U=0; dig1U=0; dig3I=0; dig1I=0; dig2I=0; break;}; //    3 
_0x140040:
	CPI  R30,LOW(0x5)
	LDI  R26,HIGH(0x5)
	CPC  R31,R26
	BRNE _0x14000B
	SBI  0x1B,3
	CBI  0x1B,4
	CBI  0x1B,5
	RCALL SUBOPT_0xD
	CBI  0x1B,1
; 000A 004F    }
_0x14000B:
; 000A 0050 
; 000A 0051    if (indy_static_I<10){    //  adc_dataI<10
	LDD  R26,Y+10
	CPI  R26,LOW(0xA)
	BRSH _0x14005A
; 000A 0052    dig2I=0; dig1I=0;         // 2  
	CBI  0x1B,1
	CBI  0x1B,2
; 000A 0053    }
; 000A 0054 
; 000A 0055    if (indy_static_I<100){   //  adc_dataI<100
_0x14005A:
	LDD  R26,Y+10
	CPI  R26,LOW(0x64)
	BRSH _0x14005F
; 000A 0056    dig2I=0;                  // 1  
	CBI  0x1B,1
; 000A 0057    }
; 000A 0058 
; 000A 0059    if (indy_static_U<10){    //  adc_dataI<10
_0x14005F:
	LDD  R26,Y+9
	CPI  R26,LOW(0xA)
	BRSH _0x140062
; 000A 005A    dig2U=0; dig1U=0;         // 2  
	CBI  0x1B,4
	CBI  0x1B,5
; 000A 005B    }
; 000A 005C 
; 000A 005D    if (indy_static_U<100){   //  adc_dataI<100
_0x140062:
	LDD  R26,Y+9
	CPI  R26,LOW(0x64)
	BRSH _0x140067
; 000A 005E    dig2U=0;                  // 1  
	CBI  0x1B,4
; 000A 005F    }
; 000A 0060 
; 000A 0061    if (divider_indy==1){
_0x140067:
	LDS  R26,_divider_indy
	CPI  R26,LOW(0x1)
	BRNE _0x14006A
; 000A 0062    PORTC=sym[sym_out[cur_dig]];   //   C   
	RCALL SUBOPT_0xB
	MOVW R26,R28
	ADIW R26,2
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	LDI  R31,0
	MOVW R26,R28
	ADIW R26,11
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	OUT  0x15,R30
; 000A 0063    cur_dig=cur_dig+1;             //  cur_dig  1
	LDD  R30,Y+8
	SUBI R30,-LOW(1)
	STD  Y+8,R30
; 000A 0064     if (cur_dig==6){
	LDD  R26,Y+8
	CPI  R26,LOW(0x6)
	BRNE _0x14006B
; 000A 0065     cur_dig=0;                    //  cur_dig     5
	LDI  R30,LOW(0)
	STD  Y+8,R30
; 000A 0066     }
; 000A 0067    }
_0x14006B:
; 000A 0068   }
_0x14006A:
; 000A 0069  divider_indy=0;                  //    
_0x140004:
	LDI  R30,LOW(0)
	STS  _divider_indy,R30
; 000A 006A  }
	ADIW R28,24
	RET

	.DSEG
_zadanie_I:
	.BYTE 0x1
_zadanie_U:
	.BYTE 0x1
_soft_start:
	.BYTE 0x1
_start1:
	.BYTE 0x1
_start:
	.BYTE 0x1
_rejim:
	.BYTE 0x1
_I_ADC:
	.BYTE 0x1
_izmerenoe_I:
	.BYTE 0x1
_U_ADC:
	.BYTE 0x1
_izmerenoe_U:
	.BYTE 0x1
_divider_500:
	.BYTE 0x2
_divider_indy:
	.BYTE 0x1
_divider_125000:
	.BYTE 0x4
_divider_2500:
	.BYTE 0x2
_button_work:
	.BYTE 0x1
_divider_button:
	.BYTE 0x1
_divider_250:
	.BYTE 0x2
_divider_pulse:
	.BYTE 0x1
_calculator_bufer_I:
	.BYTE 0x4
_calculator_bufer_U:
	.BYTE 0x4

	.CSEG
;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x0:
	LDS  R30,_zadanie_I
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x1:
	LDS  R30,_soft_start
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x2:
	LDS  R26,_rejim
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x3:
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x4:
	LDS  R26,_divider_250
	LDS  R27,_divider_250+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x5:
	OUT  0x7,R30
	LDI  R30,LOW(193)
	OUT  0x6,R30
	__DELAY_USB 43
	IN   R30,0x5
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:18 WORDS
SUBOPT_0x6:
	LDI  R31,0
	ADD  R26,R30
	ADC  R27,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x7:
	LDD  R26,Y+1
	CLR  R27
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RCALL __MODW21
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x8:
	LDD  R26,Y+1
	LDI  R27,0
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RCALL __DIVW21
	STD  Y+1,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x9:
	LD   R26,Y
	CLR  R27
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RCALL __MODW21
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0xA:
	LD   R26,Y
	LDI  R27,0
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RCALL __DIVW21
	ST   Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xB:
	LDD  R30,Y+8
	LDI  R31,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0xC:
	CBI  0x1B,5
	CBI  0x1B,4
	CBI  0x1B,3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xD:
	CBI  0x1B,0
	CBI  0x1B,2
	RET


	.CSEG
_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0xFA0
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

__ANEGW1:
	NEG  R31
	NEG  R30
	SBCI R31,0
	RET

__DIVW21U:
	CLR  R0
	CLR  R1
	LDI  R25,16
__DIVW21U1:
	LSL  R26
	ROL  R27
	ROL  R0
	ROL  R1
	SUB  R0,R30
	SBC  R1,R31
	BRCC __DIVW21U2
	ADD  R0,R30
	ADC  R1,R31
	RJMP __DIVW21U3
__DIVW21U2:
	SBR  R26,1
__DIVW21U3:
	DEC  R25
	BRNE __DIVW21U1
	MOVW R30,R26
	MOVW R26,R0
	RET

__DIVW21:
	RCALL __CHKSIGNW
	RCALL __DIVW21U
	BRTC __DIVW211
	RCALL __ANEGW1
__DIVW211:
	RET

__MODW21:
	CLT
	SBRS R27,7
	RJMP __MODW211
	COM  R26
	COM  R27
	ADIW R26,1
	SET
__MODW211:
	SBRC R31,7
	RCALL __ANEGW1
	RCALL __DIVW21U
	MOVW R30,R26
	BRTC __MODW212
	RCALL __ANEGW1
__MODW212:
	RET

__CHKSIGNW:
	CLT
	SBRS R31,7
	RJMP __CHKSW1
	RCALL __ANEGW1
	SET
__CHKSW1:
	SBRS R27,7
	RJMP __CHKSW2
	COM  R26
	COM  R27
	ADIW R26,1
	BLD  R0,0
	INC  R0
	BST  R0,0
__CHKSW2:
	RET

__GETD1P_INC:
	LD   R30,X+
	LD   R31,X+
	LD   R22,X+
	LD   R23,X+
	RET

__PUTDP1_DEC:
	ST   -X,R23
	ST   -X,R22
	ST   -X,R31
	ST   -X,R30
	RET

__INITLOCB:
__INITLOCW:
	ADD  R26,R28
	ADC  R27,R29
__INITLOC0:
	LPM  R0,Z+
	ST   X+,R0
	DEC  R24
	BRNE __INITLOC0
	RET

;END OF CODE MARKER
__END_OF_CODE:
